// @see http://www.nicovideo.jp/watch/sm13224684
// put BombSmoke.x in same folder/directory

#define particleSystemShape   1.0
#define particleSpread       20.0
#define particleSpeed         0.48
//#define particleSystemHeight 80.0
#define particleSize          5.0
#define RotateSpd             0.15
#define ScaleSpd              0.0

//#define MAX        2147483647
#define MAX             65536
//#define MAX                8192
//#define MAX             512
//#define PI                    3.14159265

//vec3 Gravity = vec3(0.0, 0.0, 0.0);
//vec3 offset  = vec3(0.0, 0.0, 1.0);

uniform float time;

varying float rad;
varying vec2  texOffset;
varying float color;

#extension GL_EXT_gpu_shader4 : enable

///**
// * @return [0.0, 1.0)
// */
//vec3 getRandom(float index) {
//	vec3 random;
//	int i = int(index);
//	random.x = float(((i<<2)+1)*(i+1) % MAX);//non linear congruential method
//	int x = int(random.x);
//	random.y = float(((x<<2)+1)*(x+1) % MAX);//non linear congruential method
//	int y = int(random.y);
//	random.z = float(((y<<2)+1)*(y+1) % MAX);//non linear congruential method
//	random    /= float(MAX);
//	return random;
//}

/**
 * @param i
 * @return [0.0, 1.0)
 */
float getRandom(int i) {
	float random;
	random  = float(((i<<2)+1)*(i+1) % MAX);//non linear congruential method
	random /= float(MAX);
	return random;
}

/**
 * @param Scale
 * @param ParticleLen
 * @param AlphaSpd
 * @param up
 */
void AllFunc(
	float  Scale,
	float  ParticleLen,
	float  AlphaSpd,
	float  up)
{
//	if(time>1.0) return;

//	int index = 0;
	int index = int(round(gl_Vertex.z*100.0));
//	int index = gl_VertexID;
	index *= 10;
//	index += 60500;
//	index += 8;
	index += int(gl_Vertex.x       + gl_Vertex.y*3.0);
//	index += int(gl_Vertex.x*100.0 + gl_Vertex.y*1100.0 + gl_Vertex.z*12100.0);
//	index += int(2.0*(gl_Vertex.x       + gl_Vertex.y*3.0));
//	gl_Vertex.z = 0.0;
	float fi = float(index)/150004.0;
//	float fi = float(index)/  1004.0;
//	float fi = float(index)/121000.0;
//	float fi = float(index)/    16.0;

//	float  t = 1.0 - frac(fi + particleSpeed);
	int    f = int(fi + particleSpeed);
	float  t = 1.0 - (fi + particleSpeed - float(f));
	float  s = pow(t, particleSystemShape);


	float  len = 1.0-time;
	len  = 1.0 - len * len;
	len *= (2.0 + t);
	len *= ParticleLen;

	//random
//	vec3  r      = getRandom(float(index)      );
	float r      = getRandom(      index       );

	vec4 pos = vec4(0.0, 0.0, 0.0, 0.0);
	//particle
	pos.x =  particleSpread * cos(48.0 * r) * len;
	pos.z =  particleSpread * cos(68.0 * r) * len;
//	pos.y =  particleSpread * cos(12.0 * r) * len;
	//flash,smoke,fire
//	pos.x =  particleSpread * cos(48.0 * r) * len;
//	pos.z =  particleSpread * sin(48.0 * r) * len;
//	pos.y = (particleSpread * cos(       r) * len * r) * up;
	pos.y =  particleSpread * cos(17.0 * r) * len;

//	vec3  w = particleSize * vec3(gl_Vertex.x, gl_Vertex.y, 0.0) * max(0.0, (1.0-t * ScaleSpd));
	float w = particleSize                                       * max(0.0, (1.0-t * ScaleSpd));

	//rotation around Z axis
//	rad = t    * RotateSpd             + cos(62.0 * fi); //particle
	rad = time * RotateSpd*(0.5-r) + t + cos(62.0 *  r); //flash,smoke,fire
//	mat3x3 matRotZ = mat3x3(
//		vec3( cos(rad), sin(rad), 0.0),
//		vec3(-sin(rad), cos(rad), 0.0),
//		vec3(     0.0,       0.0, 1.0));
//	w = matRotZ * w;

	// bill-board rotation
//	w = mul(w,inv_view_matrix);
	//scaling
//	w  = mul(w, length(world_matrix[0])*2.0*Scale) * ((1.0-time)*(1.0-AlphaSpd)*0.25 - t*0.25);
//	w *=    (                           2.0*Scale); //flash,smoke,fire
	w *=    (                           2.0*Scale) * ((1.0-time)*(1.0-AlphaSpd)*0.25 - t*0.25); //particle

//	pos += w;
	pos.xyz /= 10;

	pos.w    = gl_Vertex.w;

	gl_Position  = gl_ModelViewProjectionMatrix * pos;

	gl_PointSize = gl_Point.size / gl_Position.w * w;

//	position =      vec3(gl_ModelViewMatrix * gl_Vertex);
//	vec3 position = gl_Position.xyz;
	vec3 position = vec3(gl_ModelViewMatrix * vec4(pos.xyz,1.0));
//	vec4 position =      gl_ModelViewMatrix * vec4(pos.xyz,1.0) ;

	//alpha
	color = (1.0-time)*(1.0-AlphaSpd) - t*0.25;
	color = mix(0.0, color, min(1.0, time*32.0));
//	color = 1.0;//particle

	//texture
//	int texIndex = index%16;
//	texOffset.s  = float(texIndex%4);
//	texOffset.t  = float(texIndex/4);
}

void main(void) {
	color = 0.0;
//	if(time>1.0) return;
//	float Scale       = 1.0;//flash:10.0,  smoke:1.0, fire:1.5,  particle: 0.25
//	float ParticleLen = 0.5;//flash: 0.0,  smoke:0.5, fire:0.25, particle: 1.0
//	float AlphaSpd    = 0.5;//flash: 0.75, smoke:0.0, fire:0.75, particle:-1.0
//	float up          = 0.0;//flash: 0.0,  smoke:0.0, fire:0.0,  particle: 0.0
	float Scale       =  1.0;
	float ParticleLen =  0.5;
	float AlphaSpd    =  0.0;
	float up          =  0.0;
	AllFunc(Scale,ParticleLen,AlphaSpd,up);
}
