// @see http://flammpfeil.appspot.com/trinketbox/
// put FireParticleSystemEx.mqo in same folder/directory

#define ParticleNum	510 // depend on FireParticleSystemEx.mqo

#define particleSpeed         0.312
#define particleSystemShape   0.520
//#define particleSpread       10.00
//#define particleSystemHeight 10.0
#define particleSpread       4.0
#define particleSystemHeight 4.0
#define particleSize          0.0625

//#define MAX        2147483647
//#define MAX             65536
//#define MAX           32768
#define MAX             512 // depend on FireParticleSystemEx.mqo

uniform float time;
varying float	alpha;

#extension GL_EXT_gpu_shader4 : enable

/**
 * @param i
 * @return [0.0, 1.0)
 */
vec3 getRandom(/*float index*/int i) {
	vec3 random;
//	int i = int(index);
	random.x = float(((i<<2)+1)*(i+1) % MAX);//non linear congruential method
	int x = int(random.x);
	random.y = float(((x<<2)+1)*(x+1) % MAX);//non linear congruential method
	int y = int(random.y);
	random.z = float(((y<<2)+1)*(y+1) % MAX);//non linear congruential method
//	int z = int(random.z);
//	random.w = float(((z<<2)+1)*(z+1) % MAX);//non linear congruential method

//	random.x     = float(int(random.x)%MAX);
//	random.y     = float(int(random.y)%MAX);
//	random.z     = float(int(random.z)%MAX);
//	random.w     = float(int(random.w)%MAX);
	random    /= float(MAX);
	return random;
}

void main(void) {
	float t = gl_Vertex.x + gl_Vertex.y;
	float index = t*float(ParticleNum-1);

	// Loop particles
	t = fract(t + particleSpeed * time);

	// Determine the shape of the system
	float s = 1.0 - pow(t, particleSystemShape);

	vec4 pos = vec4(0.0, 0.0, 0.0, 0.0);
	// Move particles in a semi-random fashion
//	pos.x = particleSpread       * s * cos( 62.0 * index);
//	pos.z = particleSpread       * s                      * sin( 163.0 * index);
//	pos.y = particleSystemHeight * s * sin(-62.0 * index) * cos(-163.0 * index); // t;
	vec3 random = getRandom(int(index));
	pos.x = particleSpread       * s * (random.x-0.5);
	pos.z = particleSpread       * s * (random.z-0.5);
	pos.y = particleSystemHeight * s * (random.y-0.5);

	pos.w    = gl_Vertex.w;

	gl_Position  = gl_ModelViewProjectionMatrix * pos;

	gl_PointSize = gl_Point.size / gl_Position.w * particleSize;

	//alpha
	alpha = 1.0-t;
}
